(defun scale-saczek-run  ()
  (setq #licznik_elements (1+ #licznik_elements))
  (progress_run #licznik_elements))

(defun nowe_wspolrzedne  (base move _wsp / a)
  (setq a (polar base (angle base move) (* (DistRed base move) _wsp)))
  (list (car a) (cadr a) (caddr base)))


(defun curr_siatka  (&ld &gp / ss len w minx miny maxx maxy l)
  (if (and (setq ss (ssget "_X" (list (cons 0 #cINSERT) '(2 . "mzsk*"))))
           (> (setq len (sslength ss)) 0))
    (progn (setq l    1
                 w    (casc 10 (entget (ssname ss 0)))
                 miny (car w)
                 minx (cadr w)
                 maxy miny
                 maxx minx)
           (while (< l len)
             (setq w    (casc 10 (entget (ssname ss l)))
                   miny (min miny (car w))
                   minx (min minx (cadr w))
                   maxy (max maxy (car w))
                   maxx (max maxx (cadr w))
                   l    (1+ l)))
           (set &ld (list miny minx))
           (set &gp (list maxy maxx)))
    (progn (set &ld (getvar #limmin)) (set &gp (getvar #limmax))))
  ss)

(defun isBlockMsg  (nazwa / kc)
  (setq kc (car (kod_cyf (substr nazwa 1 4))))
  (and (>= kc 1111) (<= 1503)))


(defun SkalTeksty  (oSkala nSkala / ss l len p pv sts h)
  (if (setq ss (ssget "_X" (list (cons 0 (strcat #cTEXT "," #cMTEXT)))))
    (progn (setq sts (vla-get-TextStyles #acadDoc)
                 len (sslength ss)
                 l   0)
           (while (< l len)
             (if #licznik_elements
               (scale-saczek-run))
             (setq p  (ssname ss l)
                   pv (vlax-ename->vla-object p)
                   l  (1+ l)
                   h  (vla-get-Height (vla-Item sts (vla-get-StyleName pv))))
             (if (> h 0.0)
               (vla-put-Height pv (* h (/ nSkala 1000.0)))
               (progn (vla-put-Height pv (* (vla-get-Height pv) (/ nSkala oSkala))) (odnosnik_podkreslenie p p)))))
    (_mnil '(ss))))

(defun skalowanieBlokow  (oSkala nSkala / l len ss p vp bname XYskala skala skAttrib)
  (defun skAttrib  (item / p ea ename wspSk oh nh oitem hTxt)
    (if (arxHasAttributes item)
      (progn (setq p  item
                   en (entget item))
             (if (setq oitem (entnext p))
               (progn (while (and (setq p (entnext p)) (equal (casc 0 (setq ea (entget p))) #cATTRIB))
                        (setq oh (casc 40 ea)
                              nh (casc 40 (tblsearch "STYLE" (casc 7 ea))))
                        (if (= nh 0.0)
                          (if (and (setq hTxt (arxgetWysT (strcase (substr (casc 2 en) 1 4)))) (distof hTxt))
                            (setq nh (* (atof hTxt) (/ nSkala 1000.0)))
                            (setq nh oh))
                          (setq nh (* nh XYskala)))
                        (setq wspSk (/ nh oh)
                              ea    (subst (cons 10 (nowe_wspolrzedne (casc 10 en) (casc 10 ea) wspSk)) (assoc 10 ea) ea))
                        (if (casc 11 ea)
                          (setq ea (subst (cons 11 (nowe_wspolrzedne (casc 10 en) (casc 11 ea) wspSk)) (assoc 11 ea) ea)))
                        (setq ea (subst (cons 40 nh) (assoc 40 ea) ea))
                        (entmod ea))
                      (if (and (casc 1 (entget oitem)) (> (strlen (casc 1 (entget oitem))) 0))
                        (progn (_modifyWIPEOUT item) (odnosnik_podkreslenie item oitem))))))))
  (if (setq ss (ssget "_X" (list (cons 0 #cINSERT))))
    (progn (setq skala   (/ nSkala 1000.0)
                 XYskala skala
                 len     (sslength ss)
                 l       0)
           (while (< l len)
             (setq p  (ssname ss l)
                   vp (vlax-ename->vla-object p)
                   l  (1+ l))
             (if (not (_inPaperSpace p))
               (progn (setq bname (vla-get-Name vp))
                      (if (isBlockMsg bname)
                        (if (> nSkala 500)
                          (setq XYskala (* skala 0.75))))
                      (vla-put-XScaleFactor vp XYskala)
                      (vla-put-YScaleFactor vp XYskala)
                      (vla-put-ZScaleFactor vp XYskala)
                      (skAttrib p)     
                      ))
             (if #licznik_elements
               (scale-saczek-run)))
           (_mnil '(ss)))))

(defun skaluj_inne  (oSkala nSkala / ss l len vp p wierz i podp lnks szerokosc elist exd _pp)
  (defun _pp  (ii)
    (cond ((< ii 0) (setq ii ll))
          ((> ii ll) (setq ii 0)))
    (nth ii wierz))
  (if (setq ss (ssget "_X" (list (cons 0 #cPLINEALL) (cons 8 "OTD"))))
    (progn (setq len (sslength ss)
                 l   0)
           (while (< l len)
             (setq p   (ssname ss l)
                   exd (read_exdata p)
                   l   (1+ l))
             (if (and exd (= (setq kod (object->getCode p)) "OTDA"))
               (progn (setq wierz     (polyline->wierzcholki p)
                            ll        (1- (length wierz))
                            szerokosc (* 1.0 (/ nSkala 1000.0))
                            lnks      (get_all_link exd)
                            i         0)
                      (while (<= i ll)
                        (if lnks
                          (progn (setq podp (car lnks)
                                       lnks (cdr lnks))
                                 (setq elist (list (_pp i)
                                                   (polar (_pp i) (angle (_pp i) (_pp (1+ i))) szerokosc)
                                                   (polar (polar (_pp i) (angle (_pp i) (_pp (1+ i))) szerokosc)
                                                          (angle (_pp i) (_pp (1- i)))
                                                          szerokosc)
                                                   (polar (_pp i) (angle (_pp i) (_pp (1- i))) szerokosc)))
                                 (putCoordinates podp elist)))
                        (setq i (1+ i)))))))))

(defun skaluj_mline  (oSkala nSkala / ss l len vp p Lwt)
  (if (setq ss (ssget "_X" (list (cons 0 #cMLINE))))
    (progn (setq l   0
                 len (sslength ss))
           (while (< l len)
             (setq p  (ssname ss l)
                   vp (vlax-ename->vla-object p)
                   l  (1+ l))
             (if (not (_inPaperSpace p))
               (vla-put-MLineScale vp (* (vla-get-MLineScale vp) (/ nSkala oSkala))))
             (if #licznik_elements
               (scale-saczek-run)))
           (_mnil '(ss)))))

(defun skaluj_lineweight (oSkala nSkala / ss l len vp p)
  (if (setq ss (ssget "_X" (list (cons 0 #cPLINEALL))))
    (progn (setq l   0
                 len (sslength ss))
           (while (< l len)
             (setq p  (ssname ss l)
                   vp (vlax-ename->vla-object p)
                   l  (1+ l))
             (if (not (_inPaperSpace p))
               (progn
                 (setq Lwt (arxGetLwt (object->getCode p)))
                 (if (> lwt -1)
                   (progn
      		     (if (> nSkala 500)
        (cond ((= lwt 50)
               (setq lwt 35))
              ((= lwt 35)
               (setq lwt 25))))
                     (vlax->PutProperty vp (list (list 'Lineweight Lwt)))))
               )
             )             
            ;;;   (vla-put-MLineScale vp (* (vla-get-MLineScale vp) (/ nSkala oSkala))))
             (if #licznik_elements
               (scale-saczek-run)))
           (_mnil '(ss)))))
  

(defun skalujRys  (_limits ss_siatka OldSkala NewSkala / old_zoom isSiata ss & layers lays)
  (vla-StartUndoMark #acadDoc)
  (setq old_zoom          (get_currZoom)
        #wsp              (/ NewSkala 1000.0)
        #glob_ltscale     (/ NewSkala 1000.0)
        ss                (ssget "_X")
        #all_elements     (if ss
                            (sslength ss)
                            0)
        isSiata           (and ss_siatka (> (sslength ss_siatka) 0))
        #licznik_elements 0)
  (PUTdwg_skala (fix NewSkala))
  (if isSiata
    (foreach & (ssadd->list ss_siatka) (vla-delete (vlax-ename->vla-object &))))
  (setvarIf "REGENMODE" 0)
  (vlax-map-collection
    (vla-get-TextStyles #acadDoc)
    '(lambda (&)
       (if (> (strlen (vla-get-Name &)) 0)
         (arxMakeStyle (vla-get-Name &)))))
  (arxZoomExtents)
  (setq layers (vla-get-layers #acadDoc)
        lays   '())
  (vlax-for &  layers
    (setq lays (append lays (list (list (vla-get-Name &) (vla-get-LayerOn &)))))
    (vla-put-LayerOn & :vlax-true))
;;; Zmiana definicji blokw 
  (foreach & (vlax->ReadBloks) (redefBlock (strcat & "=" #msg_blok_path &)))
  (progress_init "Zmienia skal obiektw..." #all_elements)
  (setvarIf "REGENMODE" 0)
  (skalowanieBlokow OldSkala NewSkala)
  (SkalTeksty OldSkala NewSkala)
  (skaluj_mline OldSkala NewSkala)
  (skaluj_inne OldSkala NewSkala)

  (skaluj_lineweight OldSkala NewSkala)
  (progress_done)
  (if isSiata
    (rysuj_siatke (car _limits) (cadr _limits)))
  (arxZoomWindow (car old_zoom) (cadr old_zoom))
  (setvar "LTSCALE" #glob_ltscale)
  (setvar "SNAPUNIT" (list (/ _skala 10.0) (/ _skala 10.0)))
  (setvar "SNAPMODE" 0)
  (setvar "CMLSCALE" #wsp)
  (setvar "DIMTXT" (* 1.5 #wsp))
  (setvarIf "REGENMODE" 1)
  (foreach & lays (vla-put-LayerOn (vla-item layers (car &)) (cadr &)))
  (vla-Regen #acadDoc acActiveViewport)
  (_mnil '(#all_elements #licznik_elements ss))
  (vla-EndUndoMark #acadDoc))


(defun C:SKAL  (/ _id ss_siatka cLTSCALE _ltscale ld_curr_siatka gp_curr_siatka old_skala _skala _skalaidx what a do_idx _end)
  (defun do_idx  (key / st)
    (mode_tile cltscale
               (if (equal key "1")
                 1
                 0))
    (mode_tile "opc"
               (if (equal key "1")
                 1
                 0))
    (mode_tile "opc1"
               (if (equal key "1")
                 1
                 0))
    (setq st (< (atoi key) 5))
    (cond (st (mode_tile "usskala" 1) (set_tile "usskala" (itoa (nth (atoi key) #lst_skal))))
          (T (mode_tile "usskala" 0) (mode_tile "usskala" 2))))
  (defun _end  (var)
    (cond ((not (check_real "ldy" "Yld" T)))
          ((not (check_real "ldx" "Xld" T)))
          ((not (check_real "gpy" "Ygp" T)))
          ((not (check_real "gpx" "Xgp" T)))
          ((not (check_real "usskala" "SKALA" T)))
          (T
           (setq _skalaidx     (get_tile "skala")
                 _skala        (atof (get_tile "usskala"))
                 ld_new_siatka (list (atof (get_tile "ldy")) (atof (get_tile "ldx")))
                 gp_new_siatka (list (atof (get_tile "gpy")) (atof (get_tile "gpx"))))
           (done_dialog var))))
  (tryb T0)
  (if (>= (setq _id (load_dialog #msg_dcl_file)) 0)
    (progn (setq cLTSCALE      "ltscale"
                 _ltscale      (msg_getcfg cltscale "0")
                 ss_siatka     (curr_siatka 'ld_curr_siatka 'gp_curr_siatka)
                 ld_new_siatka ld_curr_siatka
                 gp_new_siatka gp_curr_siatka
                 old_skala     (* (dwg_skala) 1.0)
                 _skala        old_skala
                 _skalaidx     (idx_skala _skala)
                 what          2)
           (while (and (> what 1) (new_dialog "skal" _id "" #scr-pt))
             (skala_opracowania)
             (set_tile "oldx" (rtos (cadr ld_curr_siatka) 2 2))
             (set_tile "oldy" (rtos (car ld_curr_siatka) 2 2))
             (set_tile "ogpx" (rtos (cadr gp_curr_siatka) 2 2))
             (set_tile "ogpy" (rtos (car gp_curr_siatka) 2 2))
             (set_tile "ldx" (rtos (cadr ld_new_siatka) 2 2))
             (set_tile "ldy" (rtos (car ld_new_siatka) 2 2))
             (set_tile "gpx" (rtos (cadr gp_new_siatka) 2 2))
             (set_tile "gpy" (rtos (car gp_new_siatka) 2 2))
             (set_tile "old_skala" (strcat "1:" (itoa (fix old_skala))))
             (set_tile "skala" _skalaidx)
             (set_tile "usskala" (itoa (fix _skala)))
             (do_idx _skalaidx)
             (action_tile "skala" "(do_idx $value)")
             (action_tile "ld_xy" "(_end 2)")
             (action_tile "gp_xy" "(_end 3)")
             (action_tile "accept" "(_end 1)")
             (action_tile "cancel" "(done_dialog 0)")
             (setq what (start_dialog))
             (if (> what 1)
               (if (setq a (getpoint (strcat "\n"
                                             #Wskaz
                                             (cond ((= what 2) " lewe, dolne naroe")
                                                   (T " prawe, grne naroe"))
                                             " pola roboczego: ")))
                 (cond ((= what 2) (setq ld_new_siatka a))
                       (T (setq gp_new_siatka a))))))
           (unload_dialog _id)
           (if (and (eq what 1)
                    (or (/= old_skala _skala)
                        (dialog->yes_no
                          "Aktualna skala jest  identyczna z wybran.\nPo wybraniu przycisku [ Tak ] wykonana zostanie procedura skalowania i wymiany symboli.")))
             (progn (msg_setcfg cltscale _ltscale)
                    (skalujRys (list ld_new_siatka gp_new_siatka) ss_siatka old_skala _skala)))
           (_mnil '(ss_siatka))))
  (lovar))

